# (C) 2001-2024 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.

import re

def tester_function():
    print('I was called :)')

def get_parameter_values(parameter_list,emif_ip_file_path):
    parameter_list_w_pattern = [ f"<ipxact:parameter parameterId=\"{parameter}\"" for parameter in parameter_list]
    value_line_aux_counter = 0
    count_enabled = False
    info_dict = {}
    with open(emif_ip_file_path,"r") as emif_ip_file:
        for line in emif_ip_file:
            line = line.strip(" \n")
            for parameter in parameter_list_w_pattern: 
                if line.startswith(parameter):
                    value_line_aux_counter = 0
                    count_enabled = True
                    current_parameter = line.split(" ")[1][13:-1]
              
            if value_line_aux_counter == 3 and count_enabled :
                count_enabled=False
                line = re.split(r'<ipxact:value>|</ipxact:value>',line)
                info_dict[current_parameter]=line[1]
       

            if count_enabled == True:
                value_line_aux_counter = value_line_aux_counter +1
    return info_dict

def get_basic_ip_info(emif_ip_file_path) :
    
    parameter_list = ["MEM_TECHNOLOGY",
                        "MEM_NUM_CHANNELS",
                        "MEM_DEVICE_DQ_WIDTH",
                        "MEM_FORMAT",
                        "MEM_TOPOLOGY",
                        "CTRL_ECC_MODE",
                        "USER_MIN_NUM_AC_LANES"
                        ]
    extra_parameter_list = [
                        "MEM_NUM_RANKS",
                        "MEM_NUM_CHANNELS",
                        "MEM_COMPS_PER_RANK"
    ]

    basic_info = get_parameter_values(parameter_list,emif_ip_file_path)
      
    if basic_info['MEM_FORMAT'] != 'MEM_FORMAT_DISCRETE':
        return basic_info 
    elif basic_info['MEM_FORMAT'] == 'MEM_FORMAT_DISCRETE':
        if basic_info['CTRL_ECC_MODE'] =='CTRL_ECC_MODE_DISABLED':
            additional_parameters = get_parameter_values(extra_parameter_list,emif_ip_file_path)
            basic_info["MEM_DEVICE_DQ_WIDTH"] = str(int(basic_info["MEM_DEVICE_DQ_WIDTH"])*int(additional_parameters["MEM_NUM_RANKS"])*int(additional_parameters["MEM_COMPS_PER_RANK"]))
            return basic_info
        elif basic_info['CTRL_ECC_MODE'] == 'CTRL_ECC_MODE_SIDE_BAND':
            additional_parameters = get_parameter_values(extra_parameter_list,emif_ip_file_path)
            basic_info["MEM_DEVICE_DQ_WIDTH"] = str( (int(basic_info["MEM_DEVICE_DQ_WIDTH"])*int(additional_parameters["MEM_NUM_RANKS"])*int(additional_parameters["MEM_COMPS_PER_RANK"])) +8 )
            return basic_info

        
   
if __name__ == "__main__":
    get_basic_ip_info(emif_ip_file_path='./ip/ed_synth/ed_synth_emif_ph2_0.ip')